# SolidStateDetectors.jl

SolidStateDetectors.jl is a Julia package for fast 2D and 3D simulation of Solid State Detectors.

```@contents
Pages = ["man/installation.md"]
```
```@contents
Pages = ["man/config_files.md"]
```
```@contents
Pages = ["man/csg.md"]
```
```@contents
Pages = ["man/Grids.md"]
```
```@contents
Pages = ["man/electric_potential.md"]
```
```@contents
Pages = ["man/electric_field.md"]
```
```@contents
Pages = ["man/charge_drift.md"]
```
```@contents
Pages = ["man/weighting_potentials.md"]
```
```@contents
Pages = ["man/capacitances.md"]
```
```@contents
Pages = ["man/IO.md"]
```
```@contents
Pages = ["man/plotting.md"]
```

## Citing SolidStateDetectors.jl

When using SolidStateDetectors.jl for research, teaching or similar, please cite
the [paper](https://doi.org/10.1088/1748-0221/16/08/p08007).

```
@article{Abt:2021SSD,
  author        = {Abt, I. and Fischer, F. and Hagemann, F. and Hauertmann, L. and Schulz, O. and Schuster, M. and Zsigmond, A. J.},
  title         = {Simulation of semiconductor detectors in 3D with SolidStateDetectors.jl},
  year          = {2021},
  month         = {8},
  journal       = {Journal of Instrumentation},
  publisher     = {{IOP} Publishing},
  volume        = {16},
  number        = {08},
  pages         = {P08007},
  doi           = {10.1088/1748-0221/16/08/p08007},
  url           = {https://doi.org/10.1088/1748-0221/16/08/p08007}
}
```